## kubectl rollout

Manage a deployment rollout

### Synopsis


Manage a deployment using subcommands like "kubectl rollout undo deployment/abc"

```
kubectl rollout SUBCOMMAND
```

### Examples

```
  # Rollback to the previous deployment
  kubectl rollout undo deployment/abc
```

### Options inherited from parent commands

```
      --alsologtostderr                  log to standard error as well as files
      --as string                        Username to impersonate for the operation
      --certificate-authority string     Path to a cert. file for the certificate authority
      --client-certificate string        Path to a client certificate file for TLS
      --client-key string                Path to a client key file for TLS
      --cluster string                   The name of the kubeconfig cluster to use
      --context string                   The name of the kubeconfig context to use
      --insecure-skip-tls-verify         If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure
      --kubeconfig string                Path to the kubeconfig file to use for CLI requests.
      --log-backtrace-at traceLocation   when logging hits line file:N, emit a stack trace (default :0)
      --log-dir string                   If non-empty, write log files in this directory
      --logtostderr                      log to standard error instead of files
      --match-server-version             Require server version to match client version
  -n, --namespace string                 If present, the namespace scope for this CLI request
      --password string                  Password for basic authentication to the API server
      --request-timeout string           The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests. (default "0")
  -s, --server string                    The address and port of the Kubernetes API server
      --stderrthreshold severity         logs at or above this threshold go to stderr (default 2)
      --token string                     Bearer token for authentication to the API server
      --user string                      The name of the kubeconfig user to use
      --username string                  Username for basic authentication to the API server
  -v, --v Level                          log level for V logs
      --vmodule moduleSpec               comma-separated list of pattern=N settings for file-filtered logging
```

### SEE ALSO
* [kubectl](kubectl.md)	 - kubectl controls the Kubernetes cluster manager
* [kubectl rollout history](kubectl_rollout_history.md)	 - View rollout history
* [kubectl rollout pause](kubectl_rollout_pause.md)	 - Mark the provided resource as paused
* [kubectl rollout resume](kubectl_rollout_resume.md)	 - Resume a paused resource
* [kubectl rollout status](kubectl_rollout_status.md)	 - Show the status of the rollout
* [kubectl rollout undo](kubectl_rollout_undo.md)	 - Undo a previous rollout

###### Auto generated by spf13/cobra on 26-May-2017
